Home Information Classes Download Usage Mail List Requirements Links Tutorial

# Messager Class Reference

STK input control message parser. More...

`#include <Messager.h>`

Inheritance diagram for Messager:

List of all members.

## Public Member Functions

| Messager (int inputMask=0, int port=2001)
| Constructor performs initialization based on an input mask and an optional socket port.
| ~Messager ()
| Class destructor.
long | nextMessage (void)
| Check for a new input message and return the message type.
void | setRtDelta (long nSamples)
| Set the delta time (in samples) returned between valid realtime messages. This setting has no affect for scorefile messages.
long | getDelta (void) const
| Return the current message "delta time" in samples.
long | getType () const
| Return the current message type.
MY_FLOAT | getByteTwo () const
| Return the byte two value for the current message.
MY_FLOAT | getByteThree () const
| Return the byte three value for the current message.
long | getChannel () const
| Return the channel number for the current message.

## Detailed Description

STK input control message parser.

This class reads and parses control messages from a variety of sources, such as a MIDI port, scorefile, socket connection, or pipe. MIDI messages are retrieved using the RtMidi class. All other input sources (scorefile, socket, or pipe) are assumed to provide SKINI formatted messages.

For each call to nextMessage(), the active input sources are queried to see if a new control message is available.

This class is primarily for use in STK main() event loops.

One of the original goals in creating this class was to simplify the message acquisition process by removing all threads. If the windoze select() function behaved just like the unix one, that would have been possible. Since it does not (it can't be used to poll STDIN), I am using a thread to acquire messages from STDIN, which sends these messages via a socket connection to the message socket server. Perhaps in the future, it will be possible to simplify things.

by Perry R. Cook and Gary P. Scavone, 1995 - 2002.

Definition at line 63 of file Messager.h.

## Constructor & Destructor Documentation

Messager::Messager | ( | int | inputMask = 0,
|  | int | port = 2001
| ) |

Constructor performs initialization based on an input mask and an optional socket port.

The default constructor is set to read input from a SKINI scorefile. The flags STK_MIDI, STK_PIPE, and STK_SOCKET can be OR'ed together in any combination for multiple "realtime" input source parsing. An optional socket port number can be specified for use when the STK_SOCKET flag is set. For realtime input types, an StkError can be thrown during instantiation.

## Member Function Documentation

long Messager::nextMessage | ( | void |  | ) |

| Check for a new input message and return the message type. Return type values greater than zero represent valid messages. If an input scorefile has been completely read or all realtime input sources have closed, a negative value is returned. If the return type is zero, no valid messages are present.

The documentation for this class was generated from the following file:

- Messager.h

The Synthesis ToolKit in C++ (STK)
©1995-2004 Perry R. Cook and Gary P. Scavone. All Rights Reserved.